// Prise infra-rouge
// jean-Pierre MANDON 2005

#pragma chip PIC16F88

#pragma bit reception @ PORTB.0
#pragma bit sortie @ PORTB.1

#define declenchement 0x001A

#define FOSC 8000000
#define BAUD 9600
#define DEBUG 0

#include "define.h"

#pragma origin 4

#if (DEBUG==1)
 #include "uart.c"
#endif

void tempobit(void) {                // temporisation de 1,75 mS
uns16 i;
for (i=1;i<240;i++);
}

void tempohalfbit(void) {            // temporisation de 0,875 mS
uns16 i;
for (i=1;i<130;i++);
}

void main(void) {

uns16 boucle;
uns8 j;
uns16 code;
uns8 valeur;

OSCCON=0x70;                      // horloge interne  8 Mhz
while (!OSCCON.2);

PORTB=0;
TRISB=0b00000101;

#if (DEBUG)
 setup_UART();
 print_str("BONJOUR\n\r");
#endif

GIE=0;

while (1) {
          code=0;
          while (reception==1);
          tempohalfbit();
          for (j=1;j<15;j++) {
                             if (reception==0) code|=1;
                             code=code<<1;
                             tempobit();
                             }
          code=code>>1;
          code=code&0b0000011111111111;
          if (code==declenchement) {
                                   if (sortie) sortie=0;
                                   else        sortie=1;
                                   for (boucle=1;boucle<65534;boucle++);
                                   }
          #if (DEBUG)
              valeur=code.low8;
              printf(valeur);
              valeur=code.high8;
              printf(valeur);
          #endif
          }
}
